aboutsummaryrefslogtreecommitdiffhomepage
path: root/src/combine_derived_java_srcs.sh
diff options
context:
space:
mode:
authorGravatar Klaus Aehlig <aehlig@google.com>2016-10-22 07:59:41 +0000
committerGravatar John Cater <jcater@google.com>2016-10-24 19:28:00 +0000
commit4ca79d48cc8d514708dda7286fc83171bc81d4fc (patch)
tree2b49a79e6af01f1811eae10439751f348c244fd0 /src/combine_derived_java_srcs.sh
parentb8fbde3d8291c0bb2a60a714890d680e34754260 (diff)
Create a distribution artifact
...containing, besides the original sources, all generated machine-independent files needed for creating a bootstrap bazel without the need of having a protoc installed. -- Change-Id: Ib90e7896615b4067175a23fe2c942dbac4b71e4a Reviewed-on: https://bazel-review.googlesource.com/#/c/6730 MOS_MIGRATED_REVID=136910561
Diffstat (limited to 'src/combine_derived_java_srcs.sh')
-rwxr-xr-xsrc/combine_derived_java_srcs.sh37
1 files changed, 37 insertions, 0 deletions
diff --git a/src/combine_derived_java_srcs.sh b/src/combine_derived_java_srcs.sh
new file mode 100755
index 0000000000..7a306a69c3
--- /dev/null
+++ b/src/combine_derived_java_srcs.sh
@@ -0,0 +1,37 @@
+#!/bin/sh
+
+# Copyright 2016 The Bazel Authors. All rights reserved.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+set -eu
+
+# Combine src jars to a single archive containing all the source files.
+
+OUTPUT="${PWD}/$1"
+shift
+
+TMP_DIR=${TMPDIR:-/tmp}
+PACKAGE_DIR="$(mktemp -d ${TMP_DIR%%/}/bazel.XXXXXXXX)"
+trap "rm -fr \"${PACKAGE_DIR}\"" EXIT
+JAVA_SRC_DIR="${PACKAGE_DIR}/derived/src/java"
+mkdir -p "${JAVA_SRC_DIR}"
+
+for i in $*
+do
+ JARFILE="${PWD}/$i"
+ (cd "${JAVA_SRC_DIR}" && jar xf "${JARFILE}")
+done
+
+find "${PACKAGE_DIR}" -exec touch -t 198001010000.00 '{}' '+'
+(cd "${PACKAGE_DIR}" && find . -type f | sort | zip -qDX@ "${OUTPUT}")